#ifndef __gui__sidebar_h
#define __gui__sidebar_h
#include <QItemSelectionModel>
#include <QListWidget>
#include <QListWidgetItem>
class SideBar : public QListWidget {
		Q_OBJECT

	public:
		SideBar(QWidget* parent = nullptr);
		QListWidgetItem* AddItem(QString name, QIcon icon = QIcon());
		QListWidgetItem* AddSeparator();
		bool IndexIsSeparator(QModelIndex index) const;
		static QIcon CreateIcon(const char* file);

	signals:
		void CurrentItemChanged(int index);

	protected:
		virtual void mouseMoveEvent(QMouseEvent* event) override;
		QItemSelectionModel::SelectionFlags selectionCommand(const QModelIndex& index,
		                                                     const QEvent* event) const override;
		int RemoveSeparatorsFromIndex(int index);
};
#endif // __gui__sidebar_h
